local EventFrame = CreateFrame("Frame")
local Name, Realm = UnitName("player"), GetRealmName()
local format, strupper, strlower, strmatch = string.format, string.upper, string.lower, string.match

EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame:SetScript("OnEvent", function()
	JumperDB = JumperDB or {}
	JumperDB[Realm] = JumperDB[Realm] or {}
	JumperDB[Realm][Name] = JumperDB[Realm][Name] or 0
	
	hooksecurefunc("JumpOrAscendStart", function()
		if UnitOnTaxi("player") or UnitIsDead("player") or IsFlying() or IsSwimming() or not HasFullControl() then return end
		JumperDB[Realm][Name] = JumperDB[Realm][Name] + 1
	end)
end)

SlashCmdList["JUMPER"] = function(Input)
	local Message = format("Jumper: %s has jumped %s times!", Name, JumperDB[Realm][Name])
	Input = strlower(Input)
	if Input == "reset" then
		JumperDB[Realm][Name] = 0
		print("Jumper: Jump counter for " .. Name .. " has been reset to 0.")
	elseif Input == "battleground" or Input == "guild" or Input == "officer" or Input == "party" or Input == "raid" or Input == "say" or Input == "yell" then
		SendChatMessage(Message, strupper(Input))
	elseif Input == "" then
		print(Message)
	else
		local Method, Name = strmatch(Input, "(%a+)%s+(%w+)")
		if Method and Name and (Method == "tell" or Method == "whisper") then
			SendChatMessage(Message, "WHISPER", nil, Name)
		end
	end
end

SLASH_JUMPER1 = "/jump"
SLASH_JUMPER2 = "/jumper"
