--[[ Square class colored buttons for Masque ]]

local MSQ = LibStub("Masque", true)
if not MSQ then
	return
end

-- Death Knight
MSQ:AddSkin("CB: Death Knight", {
    Author = "jeffy162",
	Version = "1.1",
	Shape = "Square",
	Masque_Version = 40200,
    Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_DK]],
	},
	Icon = {
		Width = 26,
		Height = 26,
		TexCoords = {0.07,0.93,0.07,0.93},
	},
	Flash = {
		Width = 40,
		Height = 40,
		Color = {1, 0, 0, 0.6},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Overlay]],
	},
	Cooldown = {
		Width = 26,
		Height = 26,
	},
	Pushed = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Pushed]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Death Knight]],
	},
	Disabled = {
		Width = 40,
		Height = 40,
		BlendMode = "MOD",
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Disabled]],
	},
	Checked = {
		Width = 40,
		Height = 40,
		BlendMode = "ADD",
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Checked]],
	},
    Border = {
		Width = 40,
		Height = 40,
		BlendMode = "BLEND",
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Equipped]],
	},
	AutoCastable = {
		Width = 48,
		Height = 48,
		Texture = [[Interface\Buttons\UI-AutoCastableOverlay]],
	},
	Highlight = {
		Width = 40,
		Height = 40,
		BlendMode = "ADD",
		Color = {0, 0, 1, 0.9},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Highlight]],
	},
	Gloss = {
		Width = 40,
		Height = 40,
		BlendMode = "ADD",
		Color = {1, 1, 1, 0.5},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Gloss]],
	},
    HotKey = {
		Width = 40,
		Height = 10,
	--	Font = [[Interface\AddOns\Masque_ClassButtons\CBFonts\Your Font Name Goes Here]],
	--	FontSize = 12,
	--	JustifyH = "",    --Available values are LEFT, CENTER, RIGHT-- 
	--	JustifyV = "",    --Available values are BOTTOM, MIDDLE, TOP--
		OffsetX = -6,
		OffsetY = -6,
	},
	Count = {
		Width = 40,
		Height = 10,
	--	Color = {0, 0, 0, 0},
	--	Font = [[Interface\AddOns\Masque_ClassButtons\CBFonts\Your Font Name Goes Here]],
	--	FontSize = 12,
	--	JustifyH = "",    --Available values are LEFT, CENTER, RIGHT-- 
	--	JustifyV = "",    --Available values are BOTTOM, MIDDLE, TOP--
		OffsetX = -6,
		OffsetY = 4,
	},
	Name = {
		Width = 40,
		Height = 10,
	--	Color = {0, 0, 0, 0},
	--	Font = [[Interface\AddOns\Masque_ClassButtons\CBFonts\Your Font Name Goes Here]],
	--	FontSize = 12,
	--	JustifyH = "",    --Available values are LEFT, CENTER, RIGHT-- 
	--	JustifyV = "",    --Available values are BOTTOM, MIDDLE, TOP--
		OffsetX = 0,
		OffsetY = 4,
	},
	Duration = {
	    Width = 40,
		Height = 10,
	--	Color = {0, 0, 0, 0},
	--	Font = [[Interface\AddOns\Masque_ClassButtons\CBFonts\Your Font Name Goes Here]],
	--	FontSize = 12,
	--	JustifyH = "",    --Available values are LEFT, CENTER, RIGHT-- 
	--	JustifyV = "",    --Available values are BOTTOM, MIDDLE, TOP--
		OffsetX = 0,
		OffsetY = -10,
	},
    AutoCast = {
		Width = 26,
		Height = 26,
		OffsetX = 1,
		OffsetY = -1,
	},
	
}, true)

--Druid
MSQ:AddSkin("CB: Druid", {
    Template = "CB: Death Knight",
	Backdrop = {
	    Width = 40,
	    Height = 40,
	    Color = {1, 1, 1, 1},
	    Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Druid]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Druid]],
    },
}, true)

--Hunter
MSQ:AddSkin("CB: Hunter", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Hunter]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Hunter]],
	},
}, true)

-- Mage
MSQ:AddSkin("CB: Mage", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Mage]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Mage]],
	},
}, true)

-- Paladin
MSQ:AddSkin("CB: Paladin", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Paladin]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Paladin]],
	},
}, true)

-- Priest
MSQ:AddSkin("CB: Priest", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Priest]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Priest]],
	},
}, true)

-- Rogue
MSQ:AddSkin("CB: Rogue", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Rogue]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Rogue]],
	},
}, true)

-- Shaman
MSQ:AddSkin("CB: Shaman", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Shaman]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Shaman]],
	},
}, true)

-- Warlock
MSQ:AddSkin("CB: Warlock", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Warlock]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Warlock]],
	},
}, true)

-- Warrior
MSQ:AddSkin("CB: Warrior", {
    Template = "CB: Death Knight",
	Backdrop = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Backdrop_Warrior]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_ClassButtons\Textures64\Warrior]],
	},
}, true)