local absorbTable = {
	[109364] = 420000,
	[109363] = 280000,
	[190363] = 300000,
	[105479] = 200000,
	--[6788] = 300000, -- WEAKENED SOUL, REMOVE IN PRODUCTION VERSION.
}
local grow = false
local pT = {}
local debuffTable = {}
local bloodCounter = 0
local frame, events = CreateFrame("Frame","nameFrame"), {};
frame:SetScript("OnEvent", function(self, event, ...) if events[event] then events[event](self, ...) else print("no such function " .. event) end end)

frame:SetFrameStrata("BACKGROUND")
frame:SetParent(UIParent)
frame:SetWidth(64)
frame:SetHeight(64)
frame:SetMovable(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", function() frame:StartMoving() end)
frame:SetScript("OnDragStop", function() 
	frame:StopMovingOrSizing()
	searing_DB['x'] = frame:GetLeft() 
	searing_DB['y'] = frame:GetTop()
end)
local t = frame:CreateTexture(nil,"BACKGROUND")
t:SetTexture("INTERFACE\\ICONS\\Spell_Shadow_MindTwisting.BLP")
t:SetAllPoints(frame)
t:Hide()
frame.t = t

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")

function events:ADDON_LOADED(addon)
	if addon ~= "SearingPlasma" then return end
	
	print("SEARING PLASMA INIT")
	
	if not searing_DB then searing_DB = {} end
	if not searing_DB['x'] then searing_DB['x'] = 0 end
	if not searing_DB['y'] then searing_DB['y'] = UIParent:GetHeight()/2 end

	frame:ClearAllPoints()
	frame:SetPoint("BOTTOMLEFT",searing_DB['x'],searing_DB['y'])
end

function events:COMBAT_LOG_EVENT_UNFILTERED(timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName, spellFlags, amount, overhealing, absorb)
	if type == "SPELL_AURA_APPLIED" and absorbTable[spellID] then
		local index = findEmptySlot()
		debuffTable[index] = 1
		pT[destGUID] = {
			['name'] = destName,
			['GUID'] = destGUID,
			['place'] = index,
		}
		--print(pT[destGUID]['name'] .. " GOT A HEALING ABSORB")
		pT[destGUID]['absorbAmount'] = absorbTable[spellID]
		pT[destGUID]['bar'] = makeBar(pT[destGUID]['name'],pT[destGUID]['absorbAmount'],index)
	elseif type == "SPELL_AURA_REMOVED" and absorbTable[spellID] and pT[destGUID] then
		--print("HEALING ABSORB REMOVED FROM: " .. destName)
		debuffTable[pT[destGUID]['place']] = nil
		pT[destGUID]['bar']:Hide() 
		pT[destGUID] = nil
	elseif (type == "SPELL_HEAL" or type == "SPELL_PERIODIC_HEAL") and pT[destGUID] then
		--print(destName .. " GOT A HEAL FOR: " .. amount)
		pT[destGUID]['absorbAmount'] = pT[destGUID]['absorbAmount'] - absorb - amount-- absorb instead of amount
		editBar( pT[destGUID]['bar'], pT[destGUID]['absorbAmount'] )
	elseif type == "UNIT_DIED" then
		if destName == "Corrupted Blood" then
			bloodCounter = bloodCounter + 1
			print("Bloods Dead: " .. bloodCounter)
		end
	end
end

function testMode()
	for i=1,25 do
		local index = findEmptySlot()
		debuffTable[index]=1
		makeBar("test"..i, 300000, index)
	end
end

function events:PLAYER_REGEN_DISABLED()
	resetEverything()
end

function events:PLAYER_REGEN_ENABLED()
	resetEverything()
end

function findEmptySlot()
	for i=1, 25 do
		if debuffTable[i] == nil then
			return i
		end
	end
end

function resetEverything()
	for key,value in pairs(pT) do
		if value ~= nil then
			value['bar']:Hide()
		end
	end
	for i=1, 25 do
		debuffTable[i] = nil
	end
	bloodCounter = 0
end

function makeBar( name, value, index )
	local statusbar = CreateFrame("StatusBar", nil, frame)
	statusbar:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, (grow and index or -index+1) * 19)
	statusbar:SetWidth(200)
	statusbar:SetHeight(18)
	statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
	statusbar:SetStatusBarColor(1, 0.65, 0)
	statusbar:SetMinMaxValues(1,value)
	statusbar:SetValue(value)

	statusbar.bg = statusbar:CreateTexture(nil, "BACKGROUND")
	statusbar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
	statusbar.bg:SetAllPoints(true)
	statusbar.bg:SetVertexColor(0, 0, 0)

	statusbar.name = statusbar:CreateFontString(nil, "OVERLAY")
	statusbar.name:SetPoint("LEFT", statusbar, "LEFT", 4, 0)
	statusbar.name:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	statusbar.name:SetJustifyH("LEFT")
	statusbar.name:SetTextColor(1, 1, 1)
	statusbar.name:SetText(name)
	
	statusbar.value = statusbar:CreateFontString(nil, "OVERLAY")
	statusbar.value:SetPoint("RIGHT", statusbar, "RIGHT", -4, 0)
	statusbar.value:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	statusbar.value:SetJustifyH("LEFT")
	statusbar.value:SetTextColor(1, 1, 1)
	statusbar.value:SetText(value)

	return statusbar
end

function editBar(bar,amount)
	bar:SetValue(amount)
	bar.value:SetText(amount)
end

SLASH_SEARINGPLASMA1, SLASH_SEARINGPLASMA2 = '/searingplasma', '/sp'

SlashCmdList["SEARINGPLASMA"] = function(parameters)
	if parameters == "usage" or parameters == "about" then
		print("SearingPlasma")
		print("Usage: /sp [reset]")
		print("      reset:   Resets all bars")
		print("       grow:   Set bars to grow up or down")
		print("       move:   Move bars with left click")
	end
	if parameters == "move" then
		if frame.moving then
			frame.moving = nil
			frame:EnableMouse(false)
			frame.t:Hide()
			print("SearingPlasma now locked")
		else
			frame.moving = true
			frame:EnableMouse(true)
			frame.t:Show()
			print("SearingPlasma now moving")
		end
	end
	if parameters == "grow" then
		grow = not grow
		print("SearingPlasma bars now growing " .. (grow and "upwards" or "downwards"))
	end
	if parameters == "reset" then
		resetEverything()
	end
	if parameters == "reset_blood"
		bloodCounter = 0
	end
end

