local lib, oldminor = LibStub:GetLibrary("LibInternalCooldowns-1.0")

local spellToItem =
{
	-- Item lvl 397 Trinkets
	[97139] = 69150,							-- Matrix Restabilizer Haste
	[97140] = 69150,							-- Matrix Restabilizer Crit
	[97141] = 69150,							-- Matrix Restabilizer Mastery

	-- Item lvl 391 Trinkets
	[97177] = 69199,							-- Ancient Petrified Seed
	-- [97127] = 69113,							-- Apparatus of Khaz'goroth. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[97179] = 69200,							-- Essence of the Eternal Flame
	[97176] = 69198,							-- Fiery Quintessence
	[97120] = 69111,							-- Jaws of Defeat
	[97146] = 69185,							-- Rune of Zeth
	[96880] = 69109,							-- Scales of Life
	[97129] = 69138,							-- Spidersilk Spindle
	[97145] = 69184,							-- Stay of Execution
	[97125] = 69112,							-- The Hungerer

	-- Item lvl 384 Trinkets
	[96977] = 68994,							-- Matrix Restabilizer Haste
	[96978] = 68994,							-- Matrix Restabilizer Crit
	[96979] = 68994,							-- Matrix Restabilizer Mastery
	[99739] = 70399,							-- Ruthless Gladiator's Badge of Conquest
	[99741] = 70401,							-- Ruthless Gladiator's Badge of Dominance
	[99740] = 70400,							-- Ruthless Gladiator's Badge of Victory
	[99737] = {70396, 70397, 70398},					-- Ruthless Gladiator's Emblem of Cruelty, of Meditation and of Tenacity
	[99748] = 70404,							-- Ruthless Gladiator's Insignia of Conquest
	[99742] = 70402,							-- Ruthless Gladiator's Insignia of Dominance
	[99746] = 70403,							-- Ruthless Gladiator's Insignia of Victory

	-- Item lvl 379 Trinkets
	[91173] = 60233,							-- Shard of Woe

	-- Item lvl 378 Trinkets
	[97009] = 69001,							-- Ancient Petrified Seed
	-- [96934] = 68972,							-- Apparatus of Khaz'goroth. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[97010] = 69002,							-- Essence of the Eternal Flame
	[97008] = 69000,							-- Fiery Quintessence
	[96907] = 68926,							-- Jaws of Defeat
	[97007] = 68998,							-- Rune of Zeth
	[96880] = 68915,							-- Scales of Life
	[96945] = 68981,							-- Spidersilk Spindle
	[96988] = 68996,							-- Stay of Execution
	[96911] = 68927,							-- The Hungerer

	-- Item lvl 372 Trinkets
	[92318] = 65053,							-- Bell of Enraging Resonance
	[92342] = 65118,							-- Crushing Weight
	[92351] = 65140,							-- Essence of the Cyclone
	[92332] = 65124,							-- Fall of Mortality
	-- [92328] = 65110,							-- Heart of Ignacious. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92345] = 65072,							-- Heart of Rage
	-- [92331] = 65029,							-- Jar of Ancient Remedies. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92349] = 65026,							-- Prestor's Talisman of Machination
	[92355] = 65048,							-- Symbiotic Worm
	[92320] = 65105,							-- Theralion's Mirror
	[92357] = 65109,							-- Vial of Stolen Memories

	-- Item lvl 371 Trinkets
	[99711] = 70517,							-- Vicious Gladiator's Badge of Conquest
	[99712] = 70518,							-- Vicious Gladiator's Badge of Dominance
	[99713] = 70519,							-- Vicious Gladiator's Badge of Victory
	[99714] = {70563, 70564, 70565},					-- Vicious Gladiator's Emblem of Cruelty, of Meditation and of Tenacity
	[99717] = 70577,							-- Vicious Gladiator's Insignia of Conquest
	[99719] = 70578,							-- Vicious Gladiator's Insignia of Dominance
	[99721] = 70579,							-- Vicious Gladiator's Insignia of Victory

	-- Item lvl 365 Trinkets
	[101515] = 71633,							-- Aella's Bottle
	[101285] = 71333,							-- Bitterer Balebrew Charm
	[101293] = 71338,							-- Brawler's Trophy
	[101286] = 71334,							-- Bubblier Brightbrew Charm
	[101287] = 71335,							-- Coren's Chilled Chromium Coaster
	[100322] = 70141,							-- Dwyer's Caber
	[101291] = 71337,							-- Mithril Stopwatch
	[100612] = 70142,							-- Moonwell Chalice
	[101492] = 70143,							-- Moonwell Phial
	[101289] = 71336,							-- Petrified Pickled Egg
	[101515] = 70144,							-- Ricket's Magnetic Fireball
	[84969] = 61033,							-- Vicious Gladiator's Badge of Conquest
	[84968] = 61035,							-- Vicious Gladiator's Badge of Dominance
	[84966] = 61034,							-- Vicious Gladiator's Badge of Victory
	[84960] = {61026, 61031, 61030, 61032},					-- Vicious Gladiator's Emblem of Cruelty, of Meditation, of Proficiency and of Tenacity
	[85022] = 61047,							-- Vicious Gladiator's Insignia of Conquest
	[85027] = 61045,							-- Vicious Gladiator's Insignia of Dominance
	[85032] = 61046,							-- Vicious Gladiator's Insignia of Victory

	-- Item lvl 359 Trinkets
	[92233] = 58182,							-- Bedrock Talisman
	[91007] = 59326,							-- Bell of Enraging Resonance
	[91155] = 58184,							-- Core of Ripeness
	[91821] = 59506,							-- Crushing Weight
	[89181] = 62048,							-- Darkmoon Card: Earthquake
	[89091] = 62047,							-- Darkmoon Card: Volcano
	[92126] = 59473,							-- Essence of the Cyclone
	[91184] = 59500,							-- Fall of Mortality
	-- [91836] = 59461,							-- Fury of Angerforge. DO NOT USE, overwrites the actual use cooldown with the internal one!
	-- [91041] = 59514,							-- Heart of Ignacious. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[91816] = 59224,							-- Heart of Rage
	[91828] = {62464, 62469, 68712},					-- Impatience of Youth
	-- [91322] = 59354,							-- Jar of Ancient Remedies. DO NOT USE, overwrites the actual use cooldown with the internal one
	[91192] = {62467, 62472, 68711},					-- Mandala of Stirring Patterns
	[92222] = {62466, 62471, 68713},					-- Image of Immortality
	[92124] = 59441,							-- Prestor's Talisman of Machination
	[91019] = 58183,							-- Soul Casket
	[91047] = {62465, 62470, 68710},					-- Stump of Time
	[92235] = 59332,							-- Symbiotic Worm
	[91024] = 59519,							-- Theralion's Mirror
	-- [92601] = 64645,							-- Tyrande's Favorite Doll. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92108] = 59520,							-- Unheeded Warning
	[92123] = {62463, 62468, 68709},					-- Unsolvable Riddle
	[92213] = 59515,							-- Vial of Stolen Memories

	-- Item lvl 346 Trinkets
	[90992] = 56407,							-- Anhuur's Hymnal
	[91149] = 56414,							-- Blood of Isiset
	[91308] = 56463,							-- Corrupted Egg Shell
	[73549] = 52199,							-- Figurine - Demon Panther
	[73552] = 52354,							-- Figurine - Dream Owl
	[73550] = 52352,							-- Figurine - Earthen Guardian
	[73551] = 52353,							-- Figurine - Jeweled Serpent
	[73522] = 52351,							-- Figurine - King of Boars
	[92087] = 56295,							-- Grace of the Herald
	[91364] = 56393,							-- Heart of Solace
	[92187] = 56370,							-- Heart of Thunder
	[92091] = 56328,							-- Key to the Endless Chamber
	[92184] = 56347,							-- Leaden Despair
	[92094] = 56427,							-- Left Eye of Rajh
	[91352] = 56345,							-- Magnetite Mirror
	[91374] = 56458,							-- Mark of Khardros
	[91340] = 56285,							-- Might of the Ocean
	[92174] = 56280,							-- Porcelain Crab
	[91368] = 56431,							-- Right Eye of Rajh
	[91136] = 56290,							-- Sea Star
	[92099] = 56440,							-- Skardyn's Grace
	[91002] = 56400,							-- Sorrowsong
	[91139] = 56351,							-- Tear of Blood
	[90898] = 56339,							-- Tendrils of Burrowing Dark
	[92205] = 56449,							-- Throngus's Finger
	[90887] = 56320,							-- Witching Hourglass

	-- Item lvl 308-333 Trinkets
	[90989] = 55889,							-- Anhuur's Hymnal
	[91147] = 55995,							-- Blood of Isiset
	[91296] = 56136,							-- Corrupted Egg Shell
	[91363] = 55868,							-- Heart of Solace
	[92199] = 55881,							-- Impetuous Query
	[92096] = 56102,							-- Left Eye of Rajh
	[91376] = 56132,							-- Mark of Khardros
	[91370] = 56100,							-- Right Eye of Rajh
	[92098] = 56115,							-- Skardyn's Grace
	[90996] = 55879,							-- Sorrowsong
	[91341] = 66994, 							-- Soul's Anguish
	[92208] = 56121,							-- Throngus's Finger
	[92166] = {65803, 65805, 65804, 55237},					-- Harrison's Insignia of Panache, Schnotzz's Medallion of Command, Talisman of Sinister Order, Porcelain Crab 
	[92052] = {66969, 55266},						-- Heart of the Vile, Grace of the Herald 
	[95875] = 67118,							-- Electrospark Heartstarter
	[92186] = 55845,							-- Heart of Thunder
	[92069] = 55795,							-- Key to the Endless Chamber
	[92179] = 55816,							-- Leaden Despair
	[91351] = 55814,							-- Magnetite Mirror
	[91141] = 55854,							-- Rainsong
	[91138] = 55819,							-- Tear of Blood
	[90896] = 55810,							-- Tendrils of Burrowing Dark
	[91341] = 55251,							-- Might of the Ocean
	[91135] = 55256,							-- Sea Star
	[90885] = 55787,							-- Witching Hourglass

	-- PvP Trinkets (Removes all movement impairing effects and all effects which cause loss of control of your character.)
	[42292] = {70390, 70391, 70392, 70393, 70394, 70395, 70602, 70603, 70604, 70605, 70606, 70607, 60794, 60795, 60796, 60797, 60798, 60799, 60800, 60801, 60806, 60807},			

	-- Random WotLK stuff
	[64411] = 46017,							-- Val'anyr, Hammer of Ancient Kings

	[60065] = {44914, 40684, 49074},					-- Anvil of the Titans, Mirror of Truth, Coren's Chromium Coaster
	[60488] = 40373,							-- Extract of Necromatic Power
	[64713] = 45518,							-- Flare of the Heavens
	[60064] = {44912, 40682, 49706},					-- Flow of Knowledge, Sundial of the Exiled, Mithril Pocketwatch

	[67703] = {47303, 47115},						-- Death's Choice, Death's Verdict (AGI)
	[67708] = {47303, 47115},						-- Death's Choice, Death's Verdict (STR)
	[67772] = {47464, 47131},						-- Death's Choice, Death's Verdict (Heroic) (AGI)
	[67773] = {47464, 47131},						-- Death's Choice, Death's Verdict (Heroic) (STR)

	-- ICC epix
	-- Rep rings
	[72416] = {50398, 50397},
	[72412] = {50402, 50401},
	[72418] = {50399, 50400},
	[72414] = {50404, 50403},

	-- Deathbringer's Will (Non-heroic)
	[71485] = 50362,
	[71492] = 50362,
	[71486] = 50362,
	[71484] = 50362,
	[71491] = 50362,
	[71487] = 50362,

	-- Deathbringer's Will (Heroic)
	[71556] = 50363,
	[71560] = 50363,
	[71558] = 50363,
	[71561] = 50363,
	[71559] = 50363,
	[71557] = 50363,

	[71403] = 50198,							-- Needle-Encrusted Scorpion
	[71610] = 50359,							-- Althor's Abacus
	[71633] = 50352,							-- Corpse-tongue coin

	-- ICC trinkets
	[71601] = 50353,							-- Dislodged Foreign Object
	[71584] = 50358,							-- Purified Lunar Dust
	[71401] = 50342,							-- Whispering Fanged Skull
	[71605] = 50360,							-- Phylactery of the Nameless Lich
	
	-- Heroic ICC trinkets
	[71541] = 50343,							-- Whispering Fanged Skull
	[71641] = 50366,							-- Althor's Abacus
	[71639] = 50349,							-- Corpse-tongue coin
	[71644] = 50348,							-- Dislodged Foreign Object
	[71636] = 50365,							-- Phylactery of the Nameless Lich

	-- RS trinkets
	[75458] = 54569,							-- Sharpened Twilight Scale
	[75466] = 54572,							-- Charred Twilight Scale
	-- [75490] = 54573,							-- Glowing Twilight Scale
	[75477] = 54571,							-- Petrified Twilight Scale

	-- Heroic RS trinkets
	[75456] = 54590,							-- Sharpened Twilight Scale
	[75473]	= 54588,							-- Charred Twilight Scale
	-- [75495] = 54589,							-- Glowing Twilight Scale
	[75480]	= 54591,							-- Petrified Twilight Scale

	-- DK T9 2pc. WTF.
	[67117] = {48501, 48502, 48503, 48504, 48505, 48472, 48474, 48476, 48478, 48480, 48491, 48492, 48493, 48494, 48495, 48496, 48497, 48498, 48499, 48500, 48486, 48487, 48488, 48489, 48490, 48481, 48482, 48483, 48484, 48485},

	-- WotLK Epix
	[67671] = 47214,							-- Banner of Victory
	[67669] = 47213, 							-- Abyssal Rune 
	[64772] = 45609, 							-- Comet's Trail
	[65024] = 46038, 							-- Dark Matter
	[60443] = 40371,							-- Bandit's Insignia
	[64790] = 45522,							-- Blood of the Old God
	[60203] = 42990,							-- Darkmoon Card: Death
	[60494] = 40255,							-- Dying Curse
	[65004] = 65005,							-- Elemental Focus Stone
	[60492] = 39229,							-- Embrace of the Spider
	[60530] = 40258,							-- Forethought Talisman
	[60437] = 40256,							-- Grim Toll
	[49623] = 37835, 							-- Je'Tze's Bell
	[65019] = 45931, 							-- Mjolnir Runestone
	[64741] = 45490,							-- Pandora's Plea
	[65014] = 45286,							-- Pyrite Infuser
	[65003] = 45929, 							-- Sif's Remembrance
	[60538] = 40382,							-- Soul of the Dead
	[58904] = 43573,							-- Tears of Bitter Anguish
	[60062] = {40685, 49078},						-- The Egg of Mortal Essence, Ancient Pickled Egg
	[64765] = 45507, 							-- The General's Heart

	-- WotLK Blues
	[51353]	= 38358,							-- Arcane Revitalizer
	[60218] = 37220,							-- Essence of Gossamer
	[60479] = 37660,							-- Forge Ember
	[51348] = 38359,							-- Goblin Repetition Reducer
	[63250] = 45131,							-- Jouster's Fury
	[63250] = 45219,							-- Jouster's Fury
	[60302] = 37390,							-- Meteorite Whetstone
	[54808] = 40865, 							-- Noise Machine
	[60483] = 37264, 							-- Pendulum of Telluric Currents
	[52424] = 38675, 							-- Signet of the Dark Brotherhood
	[55018] = 40767,							-- Sonic Booster
	[52419] = 38674,							-- Soul Harvester's Charm
	-- [18350] = 37111,							-- Soul Preserver, no internal cooldown
	[60520] = 37657,							-- Spark of Life
	[60307] = 37064,							-- Vestige of Haldor

	-- Greatness cards
	[60233] = {44253, 44254, 44255, 42987},					-- Greatness, AGI
	[60235] = {44253, 44254, 44255, 42987},					-- Greatness, SPI
	[60229] = {44253, 44254, 44255, 42987},					-- Greatness, INT
	[60234] = {44253, 44254, 44255, 42987},					-- Greatness, STR

	-- Vanilla Epix
	[23684] = 19288								-- Darkmoon Card: Blue Dragon
}

-- spell ID = {enchant ID, slot1[, slot2]}
local enchants =
{
	-- Cataclysm
	[74245] = {4099, 16, 17},						-- Landslide
	[74241] = {4097, 16, 17},						-- Power Torrent
	[74221] = {4083, 16, 17},						-- Hurricane
	[74224] = {4084, 16},							-- Heartsong
	[75170] = {4115, 15},							-- Lightweave Embroidery (Rank 2)
	[75176] = {4118, 15},							-- Swordguard Embroidery (Rank 2)
	[75173] = {4116, 15},							-- Darkglow Embroidery (Rank 2)
	[95712] = {4175, 18},							-- Gnomish X-Ray Scope

	-- WotLK
	[55637] = {3722, 15},							-- Lightweave Embroidery (Rank 1)
	[55775] = {3730, 15},							-- Swordguard Embroidery (Rank 1)
	[55767] = {3728, 15},							-- Darkglow Embroidery (Rank 1)
	[59626] = {3790, 16}							-- Black Magic
}

local metas =
{
	[23454] = 25899,							-- Brutal Earthstorm Diamond
	[55341] = 41385, 							-- Invigorating Earthsiege Diamond
	[18803] = 25893,							-- Mystical Skyfire Diamond
	[32845]	= 25898,							-- Tenacious Earthstorm Diamond
	[39959] = 32410,							-- Thundering Skyfire Diamond
	[55379] = 41400								-- Thundering Skyflare Diamond
}

local cooldowns =
{
	-- Item lvl 397 Trinkets
	[97139] = 105,								-- Matrix Restabilizer Haste
	[97140] = 105,								-- Matrix Restabilizer Crit
	[97141] = 105,								-- Matrix Restabilizer Mastery

	-- Item lvl 391 Trinkets
	[97177] = 60,								-- Ancient Petrified Seed
	-- [97127] = 120,							-- Apparatus of Khaz'goroth. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[97179] = 60,								-- Essence of the Eternal Flame
	[97176] = 90,								-- Fiery Quintessence
	[97120] = 120,								-- Jaws of Defeat
	[97146] = 60,								-- Rune of Zeth
	[96880] = 60,								-- Scales of Life
	[97129] = 60,								-- Spidersilk Spindle
	[97145] = 120,								-- Stay of Execution
	[97125] = 60,								-- The Hungerer

	-- Item lvl 384 Trinkets
	[96977] = 105,								-- Matrix Restabilizer Haste
	[96978] = 105,								-- Matrix Restabilizer Crit
	[96979] = 105,								-- Matrix Restabilizer Mastery
	[99739] = 120,								-- Ruthless Gladiator's Badge of Conquest
	[99741] = 120,								-- Ruthless Gladiator's Badge of Dominance
	[99740] = 120,								-- Ruthless Gladiator's Badge of Victory
	[99737] = 120,								-- Ruthless Gladiator's Emblem of Cruelty, of Meditation and of Tenacity
	[99748] = 50,								-- Ruthless Gladiator's Insignia of Conquest
	[99742] = 50,								-- Ruthless Gladiator's Insignia of Dominance
	[99746] = 50,								-- Ruthless Gladiator's Insignia of Victory

	-- Item lvl 379 Trinkets
	[91173] = 60,								-- Shard of Woe

	-- Item lvl 378 Trinkets
	[97009] = 60,								-- Ancient Petrified Seed
	-- [96934] = 120,							-- Apparatus of Khaz'goroth. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[97010] = 60,								-- Essence of the Eternal Flame
	[97008] = 90,								-- Fiery Quintessence
	[96907] = 120,								-- Jaws of Defeat
	[97007] = 60,								-- Rune of Zeth
	[96880] = 60,								-- Scales of Life
	[96945] = 60,								-- Spidersilk Spindle
	[96988] = 120,								-- Stay of Execution
	[96911] = 60,								-- The Hungerer

	-- Item lvl 372 Trinkets
	[92318] = 100,								-- Bell of Enraging Resonance
	[92342] = 75,								-- Crushing Weight
	[92351] = 50,								-- Essence of the Cyclone
	[92332] = 75,								-- Fall of Mortality
	-- [92328] = 100,							-- Heart of Ignacious. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92345] = 100,								-- Heart of Rage
	-- [92331] = 30,							-- Jar of Ancient Remedies. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92349] = 75,								-- Prestor's Talisman of Machination
	[92355] = 30,								-- Symbiotic Worm
	[92320] = 50,								-- Theralion's Mirror
	[92357] = 120,								-- Vial of Stolen Memories

	-- Item lvl 371 Trinkets
	[99711] = 120,								-- Vicious Gladiator's Badge of Conquest
	[99712] = 120,								-- Vicious Gladiator's Badge of Dominance
	[99713] = 120,								-- Vicious Gladiator's Badge of Victory
	[99714] = 120,								-- Vicious Gladiator's Emblem of Cruelty, of Meditation and of Tenacity
	[99717] = 50,								-- Vicious Gladiator's Insignia of Conquest
	[99719] = 50,								-- Vicious Gladiator's Insignia of Dominance
	[99721] = 50,								-- Vicious Gladiator's Insignia of Victory

	-- Item lvl 365 Trinkets
	[101515] = 50,								-- Aella's Bottle
	[101285] = 600,								-- Bitterer Balebrew Charm
	[101293] = 120,								-- Brawler's Trophy
	[101286] = 600,								-- Bubblier Brightbrew Charm
	[101287] = 50,								-- Coren's Chilled Chromium Coaster
	[100322] = 180,								-- Dwyer's Caber
	[101291] = 50,								-- Mithril Stopwatch
	[100612] = 120,								-- Moonwell Chalice
	[101492] = 120,								-- Moonwell Phial
	[101289] = 50,								-- Petrified Pickled Egg
	[101515] = 120,								-- Ricket's Magnetic Fireball
	[84969] = 120,								-- Vicious Gladiator's Badge of Conquest
	[84968] = 120,								-- Vicious Gladiator's Badge of Dominance
	[84966] = 120,								-- Vicious Gladiator's Badge of Victory
	[84960] = 120,								-- Vicious Gladiator's Emblem of Cruelty, of Meditation, of Proficiency and of Tenacity
	[85022] = 50,								-- Vicious Gladiator's Insignia of Conquest
	[85027] = 50,								-- Vicious Gladiator's Insignia of Dominance
	[85032] = 50,								-- Vicious Gladiator's Insignia of Victory

	-- Item lvl 359 Trinkets
	[92233] = 30,								-- Bedrock Talisman
	[91007] = 100,								-- Bell of Enraging Resonance
	[91155] = 120,								-- Core of Ripeness
	[91821] = 75,								-- Crushing Weight
	[89181] = 180,								-- Darkmoon Card: Earthquake
	[89091] = 50,								-- Darkmoon Card: Volcano
	[92126] = 50,								-- Essence of the Cyclone
	[91184] = 75,								-- Fall of Mortality
	-- [91836] = 100,							-- Fury of Angerforge. DO NOT USE, overwrites the actual use cooldown with the internal one!
	-- [91041] = 100,							-- Heart of Ignacious. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[91816] = 100,								-- Heart of Rage
	[91828] = 120,								-- Impatience of Youth
	-- [91322] = 30,							-- Jar of Ancient Remedies. DO NOT USE, overwrites the actual use cooldown with the internal one
	[91192] = 50,								-- Mandala of Stirring Patterns
	[92222] = 60,								-- Image of Immortality
	[92124] = 75,								-- Prestor's Talisman of Machination
	[91019] = 120,								-- Soul Casket
	[91047] = 75,								-- Stump of Time
	[92235] = 30,								-- Symbiotic Worm
	[91024] = 50,								-- Theralion's Mirror
	-- [92601] = 60,							-- Tyrande's Favorite Doll. DO NOT USE, overwrites the actual use cooldown with the internal one!
	[92108] = 50,								-- Unheeded Warning
	[92123] = 120,								-- Unsolvable Riddle
	[92213] = 120,								-- Vial of Stolen Memories

	-- Item lvl 346 Trinkets
	[90992] = 50,								-- Anhuur's Hymnal
	[91149] = 100,								-- Blood of Isiset
	[91308] = 120,								-- Corrupted Egg Shell
	[73549] = 120,								-- Figurine - Demon Panther
	[73552] = 120,								-- Figurine - Dream Owl
	[73550] = 120,								-- Figurine - Earthen Guardian
	[73551] = 120,								-- Figurine - Jeweled Serpent
	[73522] = 120,								-- Figurine - King of Boars
	[92087] = 50,								-- Grace of the Herald
	[91364] = 100,								-- Heart of Solace
	[92187] = 180,								-- Heart of Thunder
	[92091] = 75,								-- Key to the Endless Chamber
	[92184] = 30,								-- Leaden Despair
	[92094] = 50,								-- Left Eye of Rajh
	[91352] = 90,								-- Magnetite Mirror
	[91374] = 90,								-- Mark of Khardros
	[91340] = 90,								-- Might of the Ocean
	[92174] = 80,								-- Porcelain Crab
	[91368] = 50,								-- Right Eye of Rajh
	[91136] = 120,								-- Sea Star
	[92099] = 120,								-- Skardyn's Grace
	[91002] = 20,								-- Sorrowsong
	[91139] = 75,								-- Tear of Blood
	[90898] = 75,								-- Tendrils of Burrowing Dark
	[92205] = 60,								-- Throngus's Finger
	[90887] = 75,								-- Witching Hourglass

	-- Item lvl 308-333 Trinkets
	[90989] = 50,								-- Anhuur's Hymnal
	[91147] = 100,								-- Blood of Isiset
	[91296] = 120,								-- Corrupted Egg Shell
	[91363] = 100,								-- Heart of Solace
	[92199] = 60,								-- Impetuous Query
	[92096] = 50,								-- Left Eye of Rajh
	[91376] = 90,								-- Mark of Khardros
	[91370] = 50,								-- Right Eye of Rajh
	[92098] = 120,								-- Skardyn's Grace
	[90996] = 20,								-- Sorrowsong
	[91341] = 90, 								-- Soul's Anguish
	[92208] = 60,								-- Throngus's Finger
	[92166] = 80,								-- Harrison's Insignia of Panache, Schnotzz's Medallion of Command, Talisman of Sinister Order, Porcelain Crab 
	[92052] = 50,								-- Heart of the Vile, Grace of the Herald 
	[95875] = 120,								-- Electrospark Heartstarter
	[92186] = 180,								-- Heart of Thunder
	[92069] = 75,								-- Key to the Endless Chamber
	[92179] = 30,								-- Leaden Despair
	[91351] = 90,								-- Magnetite Mirror
	[91141] = 75,								-- Rainsong
	[91138] = 75,								-- Tear of Blood
	[90896] = 75,								-- Tendrils of Burrowing Dark
	[91341] = 90,								-- Might of the Ocean
	[91135] = 120,								-- Sea Star
	[90885] = 75,								-- Witching Hourglass

	-- PvP Trinkets (Removes all movement impairing effects and all effects which cause loss of control of your character.)
	[42292] = 120,

	-- Cataclysm Enchants
	[74245] = 45,								-- Landslide
	[74241] = 50,								-- Power Torrent
	[74221] = 45,								-- Hurricane
	[74224] = 20,								-- Heartsong
	[75170] = 45,								-- Lightweave Embroidery (Rank 2)
	[75176] = 45,								-- Swordguard Embroidery (Rank 2)
	[75173] = 45,								-- Darkglow Embroidery (Rank 2)
	[95712] = 45,								-- Gnomish X-Ray Scope

	-- WotLK Enchants
	[55637] = 45,								-- Lightweave Embroidery (Rank 1)
	[55775] = 45,								-- Swordguard Embroidery (Rank 1)
	[55767] = 45,								-- Darkglow Embroidery (Rank 1)
	[59626] = 35,								-- Black Magic

	-- Meta Gems
	[23454] = 45,								-- Brutal Earthstorm Diamond
	[55341] = 45, 								-- Invigorating Earthsiege Diamond
	[18803] = 45,								-- Mystical Skyfire Diamond
	[32845]	= 45,								-- Tenacious Earthstorm Diamond
	[39959] = 45,								-- Thundering Skyfire Diamond
	[55379] = 45,								-- Thundering Skyflare Diamond

	-- ICC rep rings
	[72416] = 60,
	[72412] = 60,
	[72418] = 60,
	[72414] = 60,

	[60488] = 15,
	[51348] = 10,
	[51353] = 10,
	[54808] = 60,
	[55018] = 60,
	[52419] = 30,
	[59620] = 90,
	[55382] = 15,
	[32848] = 15,
	[55341] = 90,
	[48517] = 30,
	[48518] = 30,
	[47755] = 12,

	-- Deathbringer's Will, XI from #elitistjerks says it's 105 sec so if it's wrong yell at him.
	[71485] = 105,
	[71492] = 105,
	[71486] = 105,
	[71484] = 105,
	[71491] = 105,
	[71487] = 105,

	-- Deathbringer's Will (Heroic)
	[71556] = 105,
	[71560] = 105,
	[71558] = 105,
	[71561] = 105,
	[71559] = 105,
	[71557] = 105,

	-- Phylactery of the Nameless Lich
	[71605] = 90,
	-- Phylactery of the Nameless Lich (Heroic)
	[71636] = 90,

	-- RS trinkets
	[75458] = 45,								-- Sharpened Twilight Scale
	[75466] = 45,								-- Charred Twilight Scale
	-- [75490] = 54573,							-- Glowing Twilight Scale
	[75477] = 45,								-- Petrified Twilight Scale

	-- Heroic RS trinkets
	[75456] = 45,								-- Sharpened Twilight Scale
	[75473] = 45,								-- Charred Twilight Scale
	-- [75495] = 54589,							-- Glowing Twilight Scale
	[75480] = 45								-- Petrified Twilight Scale
}

local talents =
{
	-- Druid
	[48517] = "Eclipse",
	[48518] = "Eclipse",

	-- Hunter
	[56453] = "Lock and Load",

	-- Death Knight
	[52286] = "Will of the Necropolis",

	-- Priest
	[47755] = "Rapture",
}

lib.spellToItem = lib.spellToItem or {}
lib.cooldowns = lib.cooldowns or {}
lib.enchants = lib.enchants or {}
lib.metas = lib.metas or {}
lib.talents = lib.talents or {}

local tt, tts = {}, {}
local function merge(t1, t2)
	wipe(tts)
	for _, v in ipairs(t1) do
		tts[v] = true
	end
	for _, v in ipairs(t2) do
		if not tts[v] then
			tinsert(t1, v)
		end
	end
end

for k, v in pairs(spellToItem) do
	local e = lib.spellToItem[k]
	if e and e ~= v then
		if type(e) == "table" then
			if type(v) ~= "table" then
				wipe(tt)
				tinsert(tt, v)
			end
			merge(e, tt)
		else
			lib.spellToItem[k] = {e, v}
		end
	else
		lib.spellToItem[k] = v
	end
end

for k, v in pairs(cooldowns) do
	lib.cooldowns[k] = v
end

for k, v in pairs(enchants) do
	lib.enchants[k] = v
end

for k, v in pairs(metas) do
	lib.metas[k] = v
end

for k, v in pairs(talents) do
	lib.talents[k] = v
end