--[[
    Title: DKM
    Author: Sidh@Tarren Mill
    License: GPL
]]--

if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
   return
end

local L = LibStub("AceLocale-3.0"):GetLocale("DKM")

assert(DKM, L["Unable to locate DK Addon Object."])

ModuleBase = {}

function ModuleBase:InitBaseOptions(enabled_desc)
    self.options.args.enabled = {
        type = "toggle",
        width = "full",
        name = L["Enabled"],
        desc = enabled_desc,
        handler = self,
        get = "IsEnabledOption",
        set = "SetEnabledOption",
        order = 1
    }
    
    self.options.args.head = {
        type = "header",
        name = "Options",
        order = 2
    }
end

function ModuleBase:IsEnabledOption( info )
    return self.db.enabled
end

function ModuleBase:SetEnabledOption( info, value )
    self.db.enabled = value
    if value then
        self:Enable()
    else
        self:Disable()
    end
    
    self:ToggleOptions()
end

function ModuleBase:ToggleOptions()
    for key, option in pairs( self.options.args ) do
        if option.name ~= L["Enabled"] then
            option.disabled = not self.db.enabled
        end
    end
end

function ModuleBase:UpdateUIScale()
end

function ModuleBase:UpdateWidgetsLocking()
end
